/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR v PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.backend;

import java.awt.Font;
import musicbox.gui.MusicBoxView;

/**
 *
 * @author Administrator
 */
public class ScrollText extends Thread 
{

    String line1;
    String line2;
    String line3;
    private String beginning = "                                                                ";
    String miniBeginning = "                                                                         ";
    String space = "      ";
    String text;
    int maxLength;
    MusicBoxView mbv;
    
    int i = 0;
    int j = 0;
    int k = 0;
    int l = 0;

    public ScrollText(final String line1, final String line2, final String line3, MusicBoxView mbv) 
    {
        this.mbv = mbv;
        Font f = mbv.currentTrackInfoBox.getFont();
        int fontWidth = mbv.currentTrackInfoBox.getFontMetrics(f).stringWidth(" ");
        int boxWidth = mbv.currentTrackInfoBox.getWidth();
        int currentWidth = 0;
        beginning = "";
        while(currentWidth <= (boxWidth+fontWidth+fontWidth)){
            beginning+=" ";
            currentWidth+=fontWidth;
        }
        /*beginning = "";
        mbv.jScrollPane2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        mbv.jTextArea2.getCaret().setVisible(true);
        System.out.println(!mbv.jScrollPane2.getHorizontalScrollBar().isVisible());
        while (mbv.jTextArea2.getCaret().isVisible()) {
            beginning += "__";
            mbv.jTextArea2.setText(beginning);
            mbv.jTextArea2.setCaretPosition(beginning.length());
        }
        System.out.println("Beginnging.length: " + beginning.length());
        System.out.println(mbv.jTextArea2.getCaret().isVisible());
        //System.out.println(beginning.length());
        //beginning = beginning.replace("a"," ");
        //System.out.println(beginning.length());
        mbv.jScrollPane2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);*/
        //while (mbv.jTextArea2.getFontMetrics(mbv.jTextArea2.getFont()).stringWidth(beginning) * 3 < mbv.jTextArea2.getWidth()) {
        //    beginning = beginning + " ";
        //}
        //System.out.println(beginning.length());
        text = miniBeginning + line1 + space + line2 + space + line3;
        this.line1 = beginning + line1;
        this.line2 = beginning + line2;
        this.line3 = beginning + line3;
        //String code = "<HTML>" + beginning + line1 + "<br>" + line2 + "<br>" + line3 + "</HTML>";
        //mbv.jTextArea2.setText(code);

    }

    @Override
    @SuppressWarnings("static-access")
    public void run() 
    {
        while (mbv.back.cont)
        {
            mbv.currentTrackInfoBox.setText(line1.substring(i, line1.length()) + "\n" + line2.substring(j, line2.length()) + "\n" + line3.substring(k, line3.length()));
            if (mbv.mini != null && mbv.mini.isVisible()) 
            {
                mbv.mini.jTextField1.setText(text.substring(l, text.length()));
            }
            //System.out.println(i);
            i++;
            j++;
            k++;
            l++;
            if (i == line1.length()) 
            {
                i = 0;
            }
            if (j == line2.length()) 
            {
                j = 0;
            }
            if (k == line3.length()) 
            {
                k = 0;
            }
            if (l == text.length()) 
            {
                l = 0;
            }
            try 
            {
                Thread.sleep(250);
            } 
            catch (Exception e) 
            {
                mbv.showErrorDialog(e);
                //e.printStackTrace();
            }
        }
    }
    public void setBeginning(String beginning)
    {
        this.beginning = beginning;
    }
    public String getBeginning()
    {
        return beginning;
    }
    
    public void setLines(String line1, String line2, String line3)
    {
        text = miniBeginning + line1 + space + line2 + space + line3;
        this.line1 = beginning + line1;
        this.line2 = beginning + line2;
        this.line3 = beginning + line3;
        i = 0;
        j = 0;
        k = 0;
        l = 0;
    }
}
