/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package musicbox.backend.comparators;

import java.util.Comparator;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Administrator
 */
public class FullFileNameComparator implements Comparator<MusicOutputDesign> {

    @Override
    public int compare(MusicOutputDesign m1, MusicOutputDesign m2) {
        String fullPath1 = m1.getFilePath() + "/" + m1.getFile();
        String fullPath2 = m2.getFilePath() + "/" + m2.getFile();
        if(fullPath1.replace("\\", "/").compareToIgnoreCase(fullPath2.replace("\\","/")) < 0)
            return -1;
        else if(fullPath1.compareToIgnoreCase(fullPath2) == 0)
            return 0;
        else
            return 1;
    }

}
