/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package musicbox.backend;

import java.awt.EventQueue;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import musicbox.gui.FindFile;
import musicbox.gui.MusicBoxView;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Isaac Hammon
 */
public class FindFileRunnable implements Runnable
{
    MusicBoxView mbv;
    MusicOutputDesign currentTrack;
    MusicOutputDesign newTrack;
    boolean found = false;
    int searching = 0;
    FindFile ff;
    
    public FindFileRunnable(MusicBoxView mbv, MusicOutputDesign current)
    {
        this.mbv = mbv;
        this.currentTrack = current; 
        //ff.setVisible(true);
    }
    
    public MusicOutputDesign getNewTrack()
    {
        while(searching == 0)
        {
            System.out.print("");
        }
        if(searching == 1)
        {
            return ff.getNewFile();
        }
        else
        {
            return null;
        }
    }
    
    
    @Override
    public void run() 
    {
        if(!SwingUtilities.isEventDispatchThread())
        {
            EventQueue.invokeLater(new Runnable()
            {
                public void run()
                {
                    int r = JOptionPane.showConfirmDialog(null, "The file " + currentTrack.getFilePath() + "/" + currentTrack.getTrackTitle() + " could not be located.\nWould you like to locate this file?", "File Not Found", JOptionPane.YES_NO_OPTION);
                    if (r == JOptionPane.YES_OPTION) 
                    {
                        ff = new FindFile(MusicBoxApp.getApplication().getMainFrame(), currentTrack, mbv);
                        ff.setLocationRelativeTo(null);
                        ff.setVisible(true);
                        searching = 1;
                    }
                    else 
                    {
                       searching = -1;
                    }
                    found = true;
                }
            });
        }
        else
        {
            int r = JOptionPane.showConfirmDialog(null, "The file " + currentTrack.getFilePath() + "/" + currentTrack.getTrackTitle() + " could not be located.\nWould you like to locate this file?", "File Not Found", JOptionPane.YES_NO_OPTION);
            if (r == JOptionPane.YES_OPTION) 
            {
                
                ff = new FindFile(MusicBoxApp.getApplication().getMainFrame(), currentTrack, mbv);
                ff.setLocationRelativeTo(null);
                ff.setVisible(true);
                searching = 1;
            }
            else 
            {
               searching = -1;
            }
            found = true;
        }
        return;
    }
}
