/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.backend.comparators;

import java.util.Comparator;

/**
 *
 * @author Isaac Hammon
 */
public class TrackNumberStringComparator implements Comparator<String> 
{

    @Override
    public int compare(String trackNumber1, String trackNumber2) 
    {
        int track1 = Integer.parseInt(trackNumber1);
        int track2 = Integer.parseInt(trackNumber2);
        if(track1 < track2)
        {
            return -1;
        }
        else if(track1 == track2)
        {
            return 0;
        }
        else
        {
            return 1;
        }
    }
    
}
